#ifndef BROWSE_H
#define BROWSE_H

#include <sys/errlog.h>
#include <curses.h>

#include "options.h"
#include "listdata.h"

#define EBR_OK               0
#define EBR_INTERNAL_ERROR   1
#define EBR_EMPTY_ERROR_LOG  2


/* Commentary:

 - Browse list types (the data displayed) is defined in add_header_line() and
   add_browse_line(); Additional browse options need to be added here.

 - A shitload of redundant code can be removed by simply having
   add_header_line() check for the option to display a header, and then
   conditionally displaying it.


*/








/* =========================================================================
   Name: 
   Description: 
   Input: char *           : String to append to
          int              : Maximum chars in string to utilize
   Returns: 
   Side Effects: 
   Notes: 

*/













/* ========================================================================= */
/* These are "private" functions (really)... but have been made public because
   they are used by the search code to re-draw the page once an error-message
   or search query request was written on the page. The documentation for this
   API is "incomplete" because these functions will be joined into a single
   function in the (very near) future. */
int refresh_browse_page(struct options *o);
int refresh_hdrbr_page(struct options *o);

/* =========================================================================
   Name: Browse
   Description: Initiates the event loop for the browse functionality 
   Input: options *    : Application options
   Returns: Exit values defined at the top of this file
   Side Effects: Lots - this encompases the majority of the functionality
                 of the program. It *does not* effect the browse list, that
		 is done by the background thread, or main() before this is
		 called.
   Notes: Initially this was to be one of a couple or several major modes.
          Those modes never really materialized - meaning, they never made
	  much sense in context of what the program has been designed to do.
	  So any remaining references to this mode as "exitable" (without
	  exiting the entire app) is misguided.
*/
int Browse(struct options *o);

#endif
