#include <pthread.h>

#include "indexit.h"

/*** Globals ***/
extern struct errres *error_data;


#ifdef UNDEFINED
/* ========================================================================= */
/* Depricated - commented out */
struct errline *Indexed(struct errres *er, int index)
{
  int i;
  struct errline *reterr;

  if(NULL == er)
    return(NULL);

  if(NULL == er->el)
    return(NULL);

  reterr = er->el;

  i = 0;
  while(i < index)
  {
    i++;
    reterr = reterr->next;

    /* We ran off the end of the "array" */
    if(NULL == reterr)
      return(NULL);
  }

  return(reterr);
}
#endif



#define LOV_FORWARD 0
#define LOV_REVERSE 1

/* ========================================================================= */
int ListOffsetValue(struct errline *start,
		    struct errline *target,
		    int direction)
{
  struct errline *walker;
  int offset;

  /* If the start value is NULL then pick an end to start from */
  if(NULL == start)
  {
    switch(direction)
    {
    case LOD_FORWARD:
      walker = error_data->el;
      break;
    case LOD_REVERSE:
      walker = error_data->eol;
      break;
    default:
      return(-1);
    }
  }
  else
    walker = start;

  offset = 0;
  while(NULL != walker)
  {
    if(walker == target)
      return(offset);

    switch(direction)
    {
    case LOD_FORWARD:
      walker = walker->next;
      break;
    case LOD_REVERSE:
      walker = walker->last;
      break;
    default:
      return(-1);
    }
    offset++;
  }

  /* We encountered the end of the list. Return error. */
  return(-1);
}

/* ========================================================================= */
struct errline *ListOffsetMember(struct errline *start,
		     int offset,
		     int direction)
{
  struct errline *walker;

  if(offset < 0)
    return(NULL);

  /* If the start value is NULL then pick an end to start from */
  if(NULL == start)
  {
    switch(direction)
    {
    case LOD_FORWARD:
      walker = error_data->el;
      break;
    case LOD_REVERSE:
      walker = error_data->eol;
      break;
    default:
      return(NULL);
    }
  }
  else
    walker = start;

  while(offset != 0)
  {
    /* End of list reached. We could continue (conditionally) advancing
       the walker for a single exit point, but I am doing it this way. */
    if(NULL == walker)
      return(NULL);

    switch(direction)
    {
    case LOD_FORWARD:
      walker = walker->next;
      break;
    case LOD_REVERSE:
      walker = walker->last;
      break;
    default:
      return(NULL);
    }
    offset--;
  }

  return(walker);
}


