#ifndef SEARCH_H
#define SEARCH_H

#include "listdata.h"

/* Commentary on Search code:

 - The search is case sensitive. This is the simplified way of doing it. I
   think I prefer the emacs way that is case insensitive until the user
   starts using mixed case (and the intent is clearly case sensitive).
*/

/* =========================================================================
 * Name: DisplayMessage
 * Description: Print a string at the bottom of the display
 * Input: options - Uses this to get window info 
 *        message - The string to print on the display
 * Output: int - nothing of value.
 *         
 * Note: This *should* use var-args (like printf)         
 */
int DisplayMessage(struct options *o,
		   const char *message);

/* ========================================================================= */
/* The key difference (between this and MoveNext()) is that this will always
   ask for the search string. MoveNext() will only ask for the search string
   if it is not set.
*/
char *MoveFirst(struct options *o,
		char *needle);

/* ========================================================================= */
char *MoveNext(struct options *o,
	      char *needle);

#endif
