/*Version History:
  0.0.0   11/15/8 - Original skel proj
  0.1.0   11/15/8 - Snapped version
                  - Fixed overlapping window issue. Code is a mess.
  0.2.0   11/15/8 - Snapped version
                  - Cleanup of curses code. Minor fixes of display.
  0.3.0   11/16/8 - Cleanup of code
                  - Added command line parsing
		  - Hid cursor
                  - Added debug.h
                  - Moved browse and view data aqusition stubs to a more
                    manageable location. (That will be easily converted into
                    real retrival functions.)
  0.4.0   11/16/8 - Work on scroll capability
                  - Scroll works in browse mode but has problem when changing
                    back from view mode and *then* scrolling. (View content
                    scrolls onto the screen!)
                  - Scrolls off the end of the list! (> errors got)
  0.5.0   11/16/8 - First AIX port
                  - clear() not supported on AIX (Replaced with wclear())
                  - "true" keyword not supported on AIX
                  - Added extra CR on exit (AIX cleans up differently and
                    leaves extra chars under the command prompt).
  0.6.0   11/17/8 - Return to OSX - more curses development
                  - Fixed screen fresh issue
                  - Modified content on view page
  0.6.1   11/18/8 - Additions to this file
  0.7.0   11/18/8 - Cleanup after changes
                  - Pulled all sub-window code
                  - Added options.*
                  - Created different browse mode options
  0.8.0   11/18/8 - Snapped version prior to page up/down code
                  - Added page up / down code
                  - Simplified param list to refresh_browse_page()
  0.9.0   11/18/8 - Snapped version
                  - Code cleanup
                  - Name change - to errbr
  0.9.1   11/18/8 - Quick snap after name change
  0.9.2   11/18/8 - Quick snap with "make clean" and directory cleanup
  0.10.0  11/18/8 - (Another) Fix for page up/down code in browse mode
                  - Code cleanup
  0.11.0  11/19/8 - (Another) Fix for page up/down code in browse mode
                  - Minor work on view mode
                  - It is not clear what data mapps to what. I do not see a
                    strong corelation between the data structure and what is
                    dumped by errpt. It will be necessary to compare the
		    results of errpt with what is pulled from the errlog in
		    the structure. This (reverse engineering) needs to be done
		    on AIX.
		  - Added the -c option to filter for class (-c H or -c S)
  0.12.0   12/8/8 - Port back to AIX
                  - Addition of errlog_open, read, and close in browse.c
  0.13.0   12/9/8 - Work on the view portion of the app. Some unresolved
                    issues remain with the browse, but will be addressed after
                    view is taken care of. (What fields to display in browse)
                  - Wrote errdump to work through decoding the data. No such
                    luck. I have searched the Internet, had IBMers search W3,
		    posted a message to DeveloperWorks... No luck at this time.
  0.14.0  12/11/8 - IBM, why hath thou forsaken me? Now dumping the errpt
                    results. Most parts work, snapping version.
  0.15.0  12/12/8 - Fixed issue with view mode.
  0.16.0  12/13/8 - Code cleanup.
                  - Implemented highlight (reverse) carrat feature. Currently
                    this is a compile time option.
  0.17.0  12/14/8 - Code cleanup.
                  - Added -C option for using the "carrat" cursor.
		  - Added vi key bindings for up and down
  0.18.0    1/4/9 - Re-defined the line struct to allow use of a different
                    struct later (specifically the ability to use the IBM
		    struct). The problem is that, for a 1000 entries, the
		    difference is 64K for my (limited) struct and over 5M
		    for the IBM (full) version.
		  - Now accepts CR as a method to get into a browsable item
		    (and back out).
                  - Added the (fundamentals of the) search function
  0.19.0    1/5/9 - More work on search functionality
                  - Search complete (for now). Search works on everyting in
		    the most advanced browse view, the label, the date string
		    in two formats, but not the data fields.
		  - I made the message display more general (in browse mode).
		    It will display if the view mode fails.
		  - "Page Up" and "Page Down" keys are captured by the local
		    terminal (on OS-X). I am not implementing these. vi and
		    emacs bindings are done for these options.
  0.20.0    1/5/9 - Added Ctrl-C keybinding for exit. The user should expect
                    the app to exit if they hit Ctrl-C. This exits, but also
		    cleans up the curses stuff.
  0.20.1    1/6/9 - Changes to this file.
  0.20.1   1/18/9 - Updated errdump.c. This is not part of errbr but is used
                    to comprehend the data structures provided by the error
		    log. No changes were made to errbr, LOTS of changes were
		    made to errdump.
  0.21.0    3/6/9 - Added backspace dec 8 key support (specifically in the
                    editing of the search string). I also made the cursor
		    position more relevant to what the user should expect.
                  - "Fix" for wrap on normal browse list. This is temporary
		    as the line format needs to change anyways.
  0.22.0    3/7/9 - Acela NYP to BOS
                  - Mended the fork in developement. A fix or two was done on
                    a customer site, meanwhile some changes were sitting on
		    the version that was in the regular archive. Specifically
		    I made the following changes:
                     > Added 0.20.1 entry and errdump.c file
                     > Added *another* 0.20.1 version. The only change was the
                       addition of a ToDo. 
                  - Added a ToDo.
  0.23.0   3/24/9 - Acela BOS to NYP
                  - Added new browse list type
		  - Some cleanup on options (to pick browse list type)
  0.24.0   3/25/9 - Added browse line *_cat functions to build a browse line
                  - Reduced -b (Browse options) to two options: i and t.
		    t is a longer (formatted) time. i has the ID. All other
		    browse options were pulled - they were worthless.
  0.24.1   3/25/9 - Fixed makefile entry for errdump
                  - Fixed issue when errbr runs against an empty error log
  0.24.2   3/25/9 - Fixed error message produced from Browse();
  0.25.0    4/4/9 - NYP to BOS - Regional Service (Always take the Acela!)
                  - Added base code for the header-browse option. This will
		    show the same browse page, but with a header describing
		    the columns.
                  - Default header for default browse list type works but is
		    not bold / underlined or otherwise different
                  - Scroll up/down works
                  - Compiled on OS/X. !!! NOT TESTED ON AIX !!!
  0.26.0    4/7/9 - Split browse.c into multiple files
                  - Bug fixes with header browse
  0.27.0    4/8/9 - Look for a cloven-hooved animal in options.c. Gnarly bug.
                  - Killed a double free in view.c.
		  - Changed to a multi-dimensional array in view.c
		  - Bug squashing (miltiple pointer problems)
		  - Fixed header line for -b t (BO_LONGTIME) option
		  - Started additional help section. Ideally this will be
		    moved into another help option as in --help-keys.
  0.28.0    4/8/9 - 0.27 and 0.28 have been filled with nasty bugs. Very
                    difficult to work through. Ugh.
                  - Resolved back from error offset issue. I debuged this by
		    adding a Ctrl-L (vi binding) option to refresh the screen.
		  - Fixed to-bottom in header-mode issue.
                  - Wrote out additional info to rc file in SaveDefaults()
  0.29.0    4/9/9 - Added -I switch to turn off headers. Changed default to
                    show headers. This was done to override the settings that
		    are set in config files. Every option needs an on and off
		    switch to override system defaults.
                  - Fixed end of data jump when the end of data is < 1 page.
                  - Fixed search-jump-to when end of data is < 1 page.
  0.30.0    4/9/9 - Cantidate for release - I guess you call this beta?
                  - Yanked the remainder of the <sys/errlog.h> code
		    Specifically the directory and the header file. I hereby
		    affirm NOT to muck with the code any more to allow it to
		    compile (but not link) against OS-X - no matter how bored
		    I get on the train ride home.
                  - The intent is to (prior to release):
                    > Write a man page
		    > Package as a installp format
		    > General usage and testing
		    > Update web site
  0.31.0   4/10/9 - Added -R switch
                  - Looks for errpt on startup.
  0.32.0   4/12/9 - Changed header name of CRC ID to "Error ID"
                  - Updates to this file
  0.32.1   4/20/9 - Changes to this file
  0.32.2   4/24/9 - Fix for down-arrow in view mode
                    It is not clear what was causing this as the keys are not
		    the same. I simply removed the feature as it was not
		    important.
  0.32.3   4/24/9 - Unsucessfully tried KEY_UP and KEY_DOWN #defines in the
                    view.c keystroke loop.
  1.0.0    12/9/9 - Snapped 1.0 version prior to significant changes
  1.1.0    12/9/9 - Diving in to the pthreaded version
                  - Wrote Indexed() code to convert to index type access
		  - Modified browse.c to use new linked list methods
		  - THIS VERSION NOT COMPILED / TESTED ON AIX
		  - Note on how the screen should update:
		    > When the error list updates the cursor position should
		      not move.
                    > An option can be set to let the cursor scroll with the
		      page. This would be like a -w (watch) option that would
		      always put the cursor at the top of the page(?)
                      * No good! On a frequently updated browse list, the user
		        would never be able to reliably view the errors
		      * The watch version should only scroll freely if the
		        cursor is on the top item
                    > All updates should happen "in the background" so if you
		      are at the beginning of the list, and errors come, then
		      you should be in the middle of the list with the cursor
		      at the top of the screen (or wherever it was). So now
		      you should be able to browse "up" when you could not
		      before (the new errors arrived).
  1.2.0   12/25/9 - Actual AIX port
                  - Resolved some pointer problems.
		  - Fixed the passing of the sequence number in handle_browse()
		  - Post-op pain and fatigue end today's work. I am taking a
		    nap.
  1.3.0   2/15/10 - Cleanup in prep for threaded version.
  1.3.1   2/15/10 - Move to AIX system (continuation of previous version)
                  - Massive hackery leaves code virtually unusable
                  - 1.4 will start (pratically) from scratch
  1.4.0   2/16/10 - Still more massive changes
                  - Begin rolling in of pthread code
                    Added locks of data structure
                  - Compiles clean on AIX
		  - Browse works ok (some edge testing required)
		  - View is broken (still)
		  - Search is most likely broken (it was never updated from
		    the index based version)
		  - There is a potential data lock problem while searching. It
		    is not locked at this time. (It needs to be).
  1.5.0   2/17/10 - BOS to NYP Acela Express (Code cleanup on OS-X)
                  - Wrote the initial part of the update thread.
  1.6.0   2/17/10 - Hampton Inn - My fortress of blandatude (Code cleanup and
                    additions on OS-X - continued)
  1.7.0   2/18/10 - Curses changes
  1.8.0   2/19/10 - Back to AIX
                  - Thread code complete (missing update of dropped errors)
		  - Screen code stubbed with goto_top();
  1.9.0   2/19/10 - Snapped version at a clean point.
                  - Final fix of goto_top/goto_bottom
		  - This code should never have went 1.0. You are slipping.
		  - Fixed several errors in help code. Moved it all to usage()
  1.10.0  2/19/10 - Snapped version at a clean point.
                  - Documentation & cleanup
		  - Work on search code
  1.11.0  2/20/10 - More work on search code
                  - Search appears ok. Verify without headers (errbr -I)
  1.12.0  2/20/10 - Minor cleanup, debugging, documentation
                  - Added rmerr.sh "script"
		  - Review and fixes applied to view.c
  1.13.0  2/22/10 - Post coding review of view code suggests that it is
                    fraglie and potentially problematic. Resolutions and
		    cleanup is pressed here.
		  - Fundamental re-write of the data structures used to hold
		    data in the view mode.
                  - Commentary on threads:

		    The original idea was to put this into another file. While
		    it may be lost in this one, it is most appropriate to
		    maintain the discussion here.

		    Currently (as of this version) there is only one thread
		    and it is self-scheduling. It sleeps, then works on wake.
		    This single thread does at least two functions. The thread
		    checks for changes to the latest error in the log and
		    then adds new and marks deleted ones as unavailible.

		    The alternative (and possibly the "proper" method) is to
		    have two single purpose threads that are scheduled from
		    either the parent program or another thread. This is not
		    really a pressing problem for the new event code, but
		    the manner in which the delete code is called is a problem
		    as the updates to deleted events in the browse window do
		    not necessarily happen in the same frequency as the new
		    updates.

		    The problem with this is that *every* event must be
		    checked - constantly - to insure that they are still in
		    the actual event log. This is not realistic.

		    But why does every event need to be checked? Because some
		    kinds of events age out before others. So it is quite
		    possible for hardware errors to stick around, and other
		    errors that are newer to be aged out. So we can't always
		    just check the last event (it may be a persistent hardware
		    error). Furthermore, it is possible for an administrator
		    to clear a single error in the middle of the list using
		    the errclear command. If this were to happen, then the
		    only way of finding that error is to check for EVERY
		    single error in the list.

		    The solution is to only update the deleted items when
		    a new item is added. This prevents lots of hits to the
		    event log - for a low priority issue. Furthermore, the
		    view code can handle if an event sequence is not in the
		    log. One alternative is to check each item as part of the
		    "cursor-over" operation. If a deleted item is encountered
		    during a cursor over operation then the entire list can
		    be re-checked. This would be best done by a thread.
  1.14.0  2/22/10 - Snapped version (after significant change).
                  - Removed extra code from view.c
		  - Changed how auto-updating effects the current browse view.
		  - Looking to go into a semi-stable mode that will eventually
		    become presentable. No *major* features are expected after
		    this release.
  1.15.0  2/24/10 - Code walk. Cleanup, documentation, formatting.
                  - Added view_goto_top() and view_goto_bottom() (as well as
		    supporting view_refresh_page()). These functions are in
		    the code, but not actually used. So they could potentially
		    break the next compile, but not the code itself.
  1.16.0  2/26/10 - Clean compile on 6.1
                  - Issue discovered and partially fixed in view mode with CR
		    (actually a wrap issue) on long lines.
  1.17.0   3/6/10 - Back to 5.3
                  - Fixed problem with error exit with < 80 width screen.
		  - Relocated cursor in view mode on all movement functions.
		    This was specific to the cursor showing up in an aixterm.
		  - View mode now supports goto top and goto bottom.
  1.18.0  3/12/10 - Verification / testing on 6.1 system
                  - Wrote man page
                  - Fixed minor formatting option in -h output
  1.19.0  3/12/10 - Visited the terminal resize issue
                  - resizewin() is not availible in AIX curses. It is possible
		    to catch SIGWINCH signals and respond, but the window
		    resize functionality is not "native" to AIX curses. The
		    most reasonable response would be to implement a signal
		    handler that set a flag that could be handled on the next
		    getch() timeout. THIS IS NOT DONE AT THIS TIME.
		  - Added the keypad() call and KEY_XXXXX actions in the
		    getch() code. This is enabled through the options.h define
		    called USE_CURSES_KEYS. This is now supported in both
		    browse and view modes.
		  - Fixed a problem with error message if the screen was too
		    small on start.
  1.20.0  3/22/10 - Tested on putty => OK.
                  - "Resolved" the xterm situation on OS-X. (The problem seems
		    to be with the xterm implementation in OS-X. xterm reports
		    an invalid number for "tput lines" - one more than it
		    actually has. This is validated with the linevalidate
		    script included with the source.)
		  - Tested as regular user (without SUID/SGID, RBAC)
		    successfully.
		  - Fixed error when deleting in search string builder.
		  - "Resolved" issue with control characters in search string
		    input. The resolution is that apparently getch() returns
		    MULTIPLE values. So a control character returns the
		    control (ESC, '[') and then the character. The "fix" is to
		    only print the printable characters.
		    For example... The up arrow returns ESC, '[', and 'A'. In
		    this case, only the 'A' is printed.
		    + This does not appear to be effected by the keypad()
		      setting.
		    + Rapid presses of the up arrow do not register the same
		      as (I believe) it is within the timeout for an ESC
		      sequence. This would be settable with the notimeout()
		      call... presumably.
  1.21.0  3/23/10 - Added install target to make file
                  - Added uninstall target to make file
		  - Notes on Escape sequences:
                    + Multiple (rapid) presses of the arrow keys results in
		      quite different results. Some results are ctrl-X and
		      others are the extended sequence. They are:
		      Ctrl-[     Extended dec/char   Key
		      66 (B)     1858/B              Down Arrow
		      65 (A)     1859/C              Up Arrow
		    + getch() should always return to an int value.
		    + notimeout(w, TRUE) was added to the code. No ill effects
		      seen at this time - To the contrary, bad calls to the
		      meta sequence code have stopped.
		    + The USE_CURSES_KEYS define should be removed. With these
		      additions, it can not be avoided at this point.
		    + There is a testing table in options.h around the define
		      for USE_CURSES_KEYS along with discussion on the issue.
		  - Debug code / options were cleaned up
  1.22.0  3/23/10 - File documentation, some cleanup of filelist.txt
                  - errbr does NOT require SUID to read from the API. It *may*
		    require SUID if it was to read from the template file,
		    but since this is done via errpt we do not need SUID.
		    I successfully browsed the errlog (using errbr) via the
		    guest (id=100) account.
		  - FORCE_SCROLL_UP_PROBLEM code has been activated without
		    event. This todo is now done. The error injection code
		    has been commented out. To be removed at a later date.
		  - Resolved naming conventions / documentation of search API
		  - Fixed issue with contention of locked data with the
		    DisplayMessage() code. This was done by having the data
		    locked the entire time. This is OK because the screen
		    should-not and can-not update while it is displaying a
		    message. Should-not because it will be confusing to user.
		    Can-not because we touch the screen during unused cycles
		    in the main event loop - not sub-functions.
  1.23.0  3/23/10 - Changes only to comments..
                  - Windows telnet (on XP) worked, provided that the TERM
		    variable was set properly. It defaulted to ansi, and
		    should have been vt100. When re-set to vt100 both errbr
		    and topas worked fine. When set to the default, neither
		    worked.
  1.24.0  3/23/10 - Tested Windows telnet on Windows 7 => same as XP
                  - aixterm on Ubuntu works, provided Num Lock is off.
		  - Port on 5.3 - w/terminal testing
		  - Started work on Makefile (package target)
		  - Finished work on package target (copied from ifstat make
		    file)
  1.25.0  3/24/10 - Makefile automations
                  - Makefile documentation, formatting, clarifications
		  - Updated .PHONY targets in Makefile
		  - Added ci_strcmp() to options.h. May the gods of computer
		    optimization forgive me. (Although, if they were optimized
		    themselves, they would not care as this function is not
		    called excessively.)
		  - Added page browsing to view mode.
		  - Ctrl-l functionality added to view.c. This may not work as
		    expected. (Meaning: not work.) Testing may be required.
  1.26.0  3/26/10 - Documented APIs in various header files
                  - Code cleanup.
		  - Code should now be frozen for 2.0 release. Barring any
		    new-found bugs, the next line should be the 2.0 release.
  1.26.1  3/26/10 - Snapped version because there were two 1.26 versions in
                    existance. (Directory was moved from one system to another
		    in the middle of a version.) This snapshot ages out that
		    previous version. No other changes were made.
  2.0.0   3/29/10 - Now considered production
                  - Minor packaging improvements to Makefile and errbr.template
		    (Source is actually errbr.skel)

  EDIT_HERE - Used to jump to this location
*/
#define VERSION_STRING "2.0.0"
/*
 ToDo:

 Non-feature, code cleanup (post release):
  [ ] browse:add_header_line() needs to check to see if a header should be
      displayed or not. This should make the code much cleaner.
  [ ] Collapse browse:refresh_browse_page and browse:refresh_hdrbr_page into
      a single function.

 Major Feature (probably post 2.0):
  [ ] There is a STUB for the hard_max value set in
      errdata.c:InitializeErrorData. A real value should be read from the
      config file, and this value should be honored. This is defined and
      (someshat) documented in listdata.h - in the struct errres block.
  [ ] Case insensitive (mixed-insensitve - like emacs) search.
  [_] Handle window resize events - This will require more code than I wish
      to expend on this version. Action deferred.
  [_] Usage output for -c is wrong (and probably not supported)
  [ ] Need to create a filter for the browse.c code to pull errors. We need
      to filter on a class of errors
  [ ] It is inappropriate to only check for deleted items whenever something
      is added. This *should* work for an all delete (errclear 0) but not if
      one of the earlier items was deleted. See comments in version history.
      it is not reasonable to check *every* error on every second. The possible
      alternative is to use "cursor over" events as triggers to check for
      deleted errors. As it stands, this is not an issue for the current
      version. So, moving to long-term goals.
  [ ] Probably undocumented... Write error injection code. This will insert a
      single event such as "errbr was here". It could be triggered from an
      obscure emacs key binding.
  [ ] Implement a write feature that allows the user to save a an error message
      to a file.
  [ ] sort order of events (specifically sort ascending/descending by date)
  [ ] Ctrl-x Ctrl-s - Either save options or save the error (possibly use
      Ctrl-x Ctrl-w to save current error to a file).
  [ ] Discussion: What should we offer as input filters, we need a way to 
      limit what we show in the browse list. The problem is that this can
      get too complex... then we have just diminished the purpose of the
      ability to browse through errors and have just implemented a browsable
      version of errpt. Right now the thought is to offer only the ability
      to filter by class (H,S,O,U). This is currently enabled with the -c
      switch.

 Done:
  [X] Code freeze. Thurough testing. Release 2.0.
  [X] Improve documentation of public interfaces in listdata.h
  [X] Up-arrow and down-arrow key-code to config file. Allow the user to define
      a key sequence to handle up-arrow and down-arrow keystrokes. Confirm
      that this is an issue for terminals before committing to implementation.
      Look for the curses keyboard() or keypad() call. This may be helpful.
      (Removed. keypad() was implemented. Definition of keys should happen
      outside the app - in terminal specific key bindings. Addition here
      would represent unnessary complexity - plus: the case statement cannot
      be dynamic (at runtime). So the switch statement would need to be re-
      written. Not liking that idea.)
  [X] Improve documentation of public interfaces in browse.h. Some interfaces
      should not be published in that file.
  [X] Document public interfaces in errdata.h
  [X] Copy (tested) key values from browse.c to view.c
  [X] Support Ctrl-l (refresh page) in view mode 
  [X] Please document API and particularly "public" interfaces.
  [X] pg-down & pg-up in view mode
  [X] The RHS options in the config files are case sensitive. They should
      not be. And for that matter, the LHS options should not be case sensitive
      either.
  [X] Create "package" make file target
  [X] Remove FORCE_SCROLL_UP_PROBLEM block in browse.c before 2.0 release. It
      is currently inactive (even if defined) but should be removed for
      cleanliness reasons.
  [X] Browse::add_browse_line() needs to look for (and handle) NULL input
      for the single_error paramater.
  [X] search.c:display_message() is not thread safe. It accesses window
      geometry from error_data. It is called from within the ViewItem()
      block in browse.c.
  [X] Resolve naming convention issues of functions in search.c/h
  [X] Look for FORCE_SCROLL_UP_PROBLEM in browse.c. Activate this code to
      force an underrun that br_scroll_up should check for.
  [X] Write some additonal documentation on the USE_CURSES_KEYS define in 
      options.h
  [X] Validate how ESC sequences are evaluated. Are they processed by the
      secondary function or are they handled locally (in the main loop) by
      the [no]timeout() functionality. See notes on version 1.21.0.
  [X] Create an install target for makefile
  [X] Non-printable characters (ie up arrow) show up in search "bar" when
      typing in a search string.
  [X] Delete does not work correctly in search mode.
  [X] Test as regular user. Consider SUID or RBAC fix if there is an issue.
      Apparently not a problem. uid:gid 501:501 works fine.
  [X] Make cursor visible (if previously invisible) during search string input
  [X] Massive breakage in OS-X (XFree86) xterm. Size is wrong, scrolling is
      broken. Not errbr's fault - topas breaks too.
  [X] Long lines of dump data in view mode appear to have additional CR
      in them. Problem has been fixed in dump, line up, and line down but
      still exists in other unpublished functions. Furthremore the code
      should NOT terminate the actual data, but should copy into a string
      and terminate *that* - in the event that the user resizes while in
      view mode. The specific error happened when the screen was the default
      size and was viewing dump (binary) data. "tput cols" returned 80.
  [X] Write man page
  [X] Cursor is visible in aixterm in view mode. The cursor is NOT set to the
      bottom of the screen after each move.
  [X] Port on 6.1 system.
  [X] Remove kruft (UNDEFINED blocks) from view.c
  [X] Write additonal optional thread that checks on interval for deleted
      items. This could be done by the regular thread on an interval set
      with a timer. A flag could be set by alarm that will cause the next
      update check to trigger. This is a redundant item. See lengthy discussion
      in version 1.13 of version history. The requirements were rolled to a
      single request and put in the long-term (Major Feature) section.
  [X] New errors cause the browse list to reset. More elaborate rules should
      be established for how to deal with new errors.
  [X] view.c accesses the error_data struct and does not lock it!
  [X] The view mode appears to drop the last line! 1 bug resolvedm 1 bug found. 
  [X] Test the special case where we need to jump (after a search) to an item
      that is in the page - This means that we cannot scroll the page and must
      re-position the cursor. Furthermore, the number of items must be more
      than a single page. This will test set_found_item() in search.c. I have
      marked this portion of code with the TEST_ME label (search for it).
  [X] Can errors be deleted from the log using the API? NO they can not be
      deleted using the API, but they can be deleted (individually) using
      errclear.
  [X] Check search code without headers (see release 1.11 notes)
  [X] The thought is to have a thread blocking on a request to walk the list
      and look for sequence numbers that have been deleted. This may be overkill
      but is somthing that can be "tasked out" and is independent of the
      "add" to the list problem. The other alternative is to walk back from
      the new sequence number (until the current is encountered) and then
      check until it gets back to the oldest (smallest) seq number. (I will
      pseudo-code this)
  [X] All view panes are broken (No data is retrieved / displayed)
  [X] Add a column in browse mode that allows the use of the "valid" flag.
      The idea is that if an event has been removed from the log, and the
      event remains in the browse list, it should be marked as "deleted".
      This could be done by setting the sequence number to "*".
  [X] Usage needs to be pulled off to a function
  [X] screen data struct should hold a pointer to the error list it should
      be the grand structure for all browse operations. Many functions call
      for the screen data struct as well as a screen data struct member. This
      should be cleaned up.
  [X] Continually check for updates to errlog, insert new errors at top of
      the list. This would require that the array be changed to a linked
      list.
  [X] goto_bottom() and goto_top() are broken. They display a page of the same
      errors. Scrolling fixes the problem. -> Problem was in refresh_hdrbr_page
      Count is still off. Both work fine if the list of errors is less than the
      page size. Both work fine if list is > than page size. Still needs to be
      checked when not using a header.
  [X] Implement the thread code as non-threaded first. Create a hidden (un-
      documented) key to update the page on command (rather than jumping
      into the pthread code *and* implementing the linked list change-over.
  [X] Implement a thread that watches the error log for updates
  [X] Kill ewatch.c (possibly reuse the name)
  [X] Write a function to update data - call from Browse event loop.
  [X] Port 1.5.0 to AIX
  [X] Resolve issue of locking with search (mv_first()/mv_next()) code.
  [X] Create a "proper" va_list implementation of DebugOut().
  [X] Check for errpt on startup.
  [X] Test the system defaults in /etc/errbr.rc
  [X] Search jump-to fails (scrolls into bad data) when there is not a full
      page of data.
  [X] end-of-data jump-to fails when there is less than a page of data.
  [X] Jump to bottom breaks when the page is not full
  [X] Document all the key bindings.
  [X] Write out documentation info to rc file
  [X] to_bottom is broken (off by one) in header mode
  [X] Return from view mode is broken when using header option
  [X] Horrendus memory problem happening somewhere in the new code. Brutal.
  [X] SaveOptions is not complete
  [X] Break browse.c into multiple files. It is getting difficult to find
      your way around in.
  [X] Remove UNDEFINED code from browse.c. It was created in 0.24.0 and left
      for archival purposes. It should be out by 0.26.0
  [X] Terminate the lines before passing them to curses. This will serve as a
      hard-stop on any line wrap issues. It is better to have garbled lines
      than a garbled display (because when lines wrap in curses, they wreck
      *everything*).
  [X] Another problem with the browse list not scrolling correctly (even in
      once "resolved" browse modes).
  [X] Find the ID that we want from errdump.c and add this to browse options.
  [X] Finish new Browse Option
  [X] Problem with wrap on the normal browse list (line is too long). I have
      plans to change this anyways.
  [X] Consider changing the -c switch to -H, -S, -O, and -U. These switches 
      should be stackable and/or replaceable with a -A for (all). But then
      again, -A will be the default browse type. The switches and type
      paramater to the switch is crafty, but complex. I prefer to remove
      both the -c and -b switches in favor of stackable / exclusive options.
      (The ability to do this is in the code as of 0.24.0 but it is not
      leveraged, and I expect that it will not. I do not see the number of
      different data types significant enough to provide any meaningful
      variations on the browse list types, and furthermore, this is more than
      the average user would use - the point of this tool is simplicity, not
      tons of options).
  [X] Implement proper pg-down pg-up keys
  [X] Goto end of browse list (top and bottom)
  [X] Need to handle a failed ViewItem() call.
  [X] Ability to a search in browse mode
  [X] Finish view mode (works - be more specific as to requirements)
  [X] What if we have more than MAX lines from errpt call. Fix this.
  [X] Definite memory leak on returning from view mode
  [X] Fix pg-down and pg-up keys for highlight browse mode (never broken)
  [X] View mode does not display correctly. Scroll seems backward.
  [X] What if we have less than 23 lines from errpt call. Fix this.
  [X] Stub out AIX functions as much as possible (final move to AIX will be
      minimal).
  [X] Evaluate the value of having two windows if you need to re-paint the
      entire window anyways. (dumped dual window business)
  [X] No indication what el_identifier is. It is not in the AIX structures.
      Where did you get this from?
  [X] Change input count - debug problems.
  [X] Put random data in sequence # and debug (verify)
  [X] Still have a problem in browse page down / up code! (The problem was
      that the error currsor was equally incramented with the topindex. The
      fix was to insure that we always set the cursor to the top index
      regardless of where it was before page operation.)
  [X] ESC gets you out of view mode (No workie. Down arrow (apparently) uses
      the esc modifier. Down arrow is captured by the esc exit clause.)
  [X] Feature request: Page (not just line) scrolling in browse mode
  [X] Watch the memory size during use - look for leaks
  [X] Fork off options code to another file. The idea is to allow for an
      ~/.errbrowse file - should you develop those options.
  [X] The screen data struct needs to hold more than the current window. It
      is more complexity than it is worth. Currently all values that you use
      are directly availible from the WINDOW structure.
  [X] Support options for different browse options
  [X] Clean up chelper code
  [X] Problem with residual data when moving between modes. AIX and OSX behave
      differently, but both have problems. This is (partially) caused by the
      additon of wclear() over clear() (an AIX requirement).
  [X] Implement scroll mode (Browse mode - done)
  [X] Browse scrolls of the bottom of the list.
  [X] Compile errors on AIX
  [X] Handle printing version string
  [X] Make the cursor invisible!
  [X] Browse list does not refresh on return from view
  [X] Get basics of curses library into code
*/

