#ifndef VIEW_H
#define VIEW_H

#include <curses.h>

/* =========================================================================
 * Name: ViewItem
 * Description: Display the specific error entry on the screen
 * Input: item - The sequence number of the error log entry
 *        w    - The window to be displaying in
 * Output: int - nothing of value.
 *         
 * Note: 
 */

int ViewItem(unsigned int item, WINDOW *w);

/* =========================================================================
 * Name: GotErrptBinary
 * Description: Determine if errpt exists where it is expected
 * Input: None
 * Output: int - boolean. 1 = got it, 0 = don't got it.
 *         
 * Note: This just stats the file. It does not check for executable or SUID
 *       bits.
 */
int GotErrptBinary(void);

#endif
